public class Frame
{
    private int    ball1;
    private int    ball2;
    private Frame nextFrame;

    public Frame()
    {
        ball1 = -1;
        ball2 = -1;
        nextFrame = null;
    }

    // ------------------------------------------------ Public methods

    public void roll( int ball )
    {
        if ( ball1 == -1 )
            ball1 = ball;
        else if ( ball1 != 10 && ball2 == -1 )
            ball2 = ball;
        else
        {
            if ( nextFrame == null )
                nextFrame = new Frame();
            nextFrame.roll( ball );
        }
    }

    public int score()
    {
        if ( ball1 == 10 )
            return 10 + nextFrame.firstBall() + nextFrame.secondBall();

        int total = ball1 + ball2;
        if ( total == 10 )
            return 10 + nextFrame.firstBall();

        return ball1 + ball2;
    }

    public int gameScore()
    {
        return gameScore( 1 );
    }

    public String ballString()
    {
        return ballString( 1 );
    }

    public String totalString()
    {
        return totalString( 1, 0 );
    }

    // ------------------------------------------------ Helper methods

    private int gameScore( int frameNumber )
    {
        if (( nextFrame == null ) || ( frameNumber == 10 ))
            return score();
        return score() + nextFrame.gameScore( frameNumber + 1 );
    }

    private String ballString( int frameNumber )
    {
        if ( frameNumber == 10 )
            return ballStringForTenthFrame();

        String stringForFrame = "";
        if ( ball1 == 10 )
            stringForFrame = "XXX|";
        else if ( ball1 + ball2 == 10 )
            stringForFrame = stringForFrame + ball1 + " /|";
        else
            stringForFrame = stringForFrame + ball1 + " " + ball2 + "|";

        if (( nextFrame == null ) || ( frameNumber == 10 ))
            return stringForFrame;
        return stringForFrame + nextFrame.ballString( frameNumber+1 );
    }

    private String ballStringForTenthFrame()
    {
        String stringForFrame = "";
        if ( ball1 == 10 )
        {
            int bonusBallOne = nextFrame.firstBall();
            String bonusBallOneString =
                ( bonusBallOne == 10 ) ? " X" : " " + bonusBallOne;
            int bonusBallTwo = nextFrame.secondBall();
            String bonusBallTwoString =
                ( bonusBallTwo == 10 ) ? " X" : " " + bonusBallTwo;
            stringForFrame = "X" + bonusBallOneString +
                             bonusBallTwoString + "|";
        }
        else if ( ball1 + ball2 == 10 )
        {
            int bonusBall = nextFrame.firstBall();
            String bonusBallString =
                ( bonusBall == 10 ) ? " X" : " " + bonusBall;
            stringForFrame = stringForFrame + ball1 + " /" +
                            bonusBallString + "|";
        }
        else
            stringForFrame = stringForFrame + ball1 + " " + ball2 + "|";

        return stringForFrame;
    }

    private String totalString( int frameNumber, int runningTotal )
    {
        runningTotal = runningTotal + score();
        String answer = leadingSpaces( runningTotal ) + runningTotal + "|";

        if (( nextFrame == null ) || ( frameNumber == 10 ))
            return answer;
        return answer + nextFrame.totalString( frameNumber+1, runningTotal );
    }

    private String leadingSpaces( int score )
    {
        if ( score >= 100 )
            return "";
        if ( score >= 10 )
            return " ";
        return "  ";
    }

    private int firstBall()
    {
        return ball1;
    }

    private int secondBall()
    {
        if ( ball2 == -1 )
            return nextFrame.firstBall();
        return ball2;
    }
}
