import java.io.FileWriter;
import java.io.IOException;

public class GenerateTest
{
    public static void main( String[] args )
    {
        try {
            String testName = args[0];
            FileWriter writer = new FileWriter( testName + ".java" );

            String fileContents = makeTestCase( testName );
            writer.write( fileContents, 0, fileContents.length() );
            writer.close();
        } catch (IOException e) {
            System.err.println( "Error creating file.  Aborted." );
            System.exit( -1 );
        }
    }

    protected static String makeTestCase( String testname )
    {
        return
        "import junit.framework.*;\n" +
        "\n" +
        "public class " + testname + " extends TestCase\n" +
        "{\n" +
        "    protected void setUp()\n" +
        "    {\n" +
        "    }\n" +
        "\n" +
        "    public void testOne()\n" +
        "    {\n" +
        "    }\n" +
        "\n" +
        "    public static Test suite()\n" +
        "    {\n" +
        "        return new TestSuite( " + testname + ".class );\n" +
        "    }\n" +
        "\n" +
        "    public static void main( String[] args )\n" +
        "    {\n" +
        "        junit.textui.TestRunner.run( suite() );\n" +
        "    }\n" +
	"}";
    }
}
